//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormSpeedDial.h"
#include "SpeedDialPanel.h"
#include "FormSpeedDialEdit.h"
#include "Settings.h"
#include "UaMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmSpeedDial *frmSpeedDial;

namespace {
	enum { PANELS_CNT = 10 };
}

//---------------------------------------------------------------------------
__fastcall TfrmSpeedDial::TfrmSpeedDial(TComponent* Owner, CallbackCall callbackCall)
	: TForm(Owner), callbackCall(callbackCall)
{
	assert(callbackCall);
	assert(PANELS_CNT == UaConf::CONTACTS_CNT);
	for (int i=0; i<PANELS_CNT; i++)
	{
		TSpeedDialPanel *panel = new TSpeedDialPanel(flowPanel, imgList);
        panel->Tag = i;
		panel->Parent = flowPanel;
		panel->Width = flowPanel->Width-2;
		panel->Height = 32;
		//panel->AlignWithMargins = true;
		if (i < appSettings.uaConf.contacts.size())
		{
			UaConf::Contact &contact = appSettings.uaConf.contacts[i];
			panel->SetDescription(contact.description.c_str());
			panel->SetUser(contact.user.c_str());
		}
		else if (i == 0)
		{
			panel->SetDescription("RMB to edit");
		}
		panel->OnClick = SpeedDialPanelClick;
        panel->PopupMenu = popupPanel;
		panel->UpdateCallbacks();
		panel->Visible = True;
		vpanels.push_back(panel);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSpeedDial::SpeedDialPanelClick(TObject *Sender)
{
	TSpeedDialPanel* panel = dynamic_cast<TSpeedDialPanel*>(Sender);
	if (panel == NULL)
	{
		TComponent *component = dynamic_cast<TComponent*>(Sender);
		assert(component);
		panel = dynamic_cast<TSpeedDialPanel*>(component->Owner);
	}
	assert(panel);
	int id = panel->Tag;

	UaConf::Contact &contact = appSettings.uaConf.contacts[id];

	if (contact.user == "")
	{
		EditContact(id);
		return;
	}

	/** \todo Call pickup */
	callbackCall(contact.user.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TfrmSpeedDial::miEditSpeedDialClick(TObject *Sender)
{
	TSpeedDialPanel* panel = dynamic_cast<TSpeedDialPanel*>(popupPanel->PopupComponent);
	assert(panel);
	int id = panel->Tag;

	EditContact(id);
}
//---------------------------------------------------------------------------

void TfrmSpeedDial::EditContact(int id)
{
	UaConf::Contact &contact = appSettings.uaConf.contacts[id];

	frmSpeedDialEdit->edDescription->Text = contact.description.c_str();
	frmSpeedDialEdit->edNumber->Text = contact.user.c_str();
	frmSpeedDialEdit->chbDialogInfoSubscribe->Checked = contact.sub_dialog_info;

	frmSpeedDialEdit->ShowModal();

	if (frmSpeedDialEdit->isConfirmed())
	{
		UaConf::Contact new_contact;
		new_contact.description = frmSpeedDialEdit->edDescription->Text.c_str();
		new_contact.user = frmSpeedDialEdit->edNumber->Text.c_str();
		new_contact.sub_dialog_info = frmSpeedDialEdit->chbDialogInfoSubscribe->Checked;
		if (new_contact != contact)
		{
			contact = new_contact;
            TSpeedDialPanel* panel = vpanels[id];
			panel->SetDescription(contact.description.c_str());
			panel->SetUser(contact.user.c_str());
			AnsiString asConfigFile = ChangeFileExt( Application->ExeName, ".json" );
			appSettings.Write(asConfigFile);

			Ua::Instance().Restart();			
		}
	}
}

void TfrmSpeedDial::UpdateDlgInfoState(int id, int state)
{
	if (id >= vpanels.size())
		return;	
	vpanels[id]->SetState((enum dialog_info_status)state);
}


